// - Nastaveni projektu: output path, output type, target framework (kde a co je vystup)
// - Struktura aplikace: reference, Namespace, using, classes
// - try, catch
// - switch
// - region
// - Debugging, krokovanie F10,F11, vraceni provedene operace
// - krokujte program, Okna: Watch, BreakPoints, conditional break point, call stack object browser
// - vyskousejte System.Diagnostics.Debug.Write("");
// - vytvorte namespace IW5_cv01.Math v novem projektu typu knihovna, pridejte referenci
// - v tomto projektu vytvorte funkce pre nasobeni, deleni, odcitani a stitani
// - vyuzitim tohoto suboru vytvorte jednoduchy kalkulator v konzole
// - vyskousejte praci s parametry args, s kterymi byla aplikace spustena,
// -   (Project > Properties > Debug > Command line arguments)
// - Skuste puzivat System.Math funkcie
// - pozor na delenie nulou!

// - volitelne: seznamte sa s programem Wordcount v adresari cvicenia: zamerte sa na StreamReader, HashTable, foreach

// Prikazmi using urcuju, jake namespace se budou pouzivat v danem souboru
// Ak pouzijem using, tak namespace je importovany a nemusime pouzit napr. System.Diagnostics.Debug.Write(),
// ale po importu using namespace System.Diagnostics staci psat jen Debug.Write().
// Pozor! jestli udelam import dvou namespace, ktere obsahuji stejnou tridu
// potom dojde ke konfliktu, a budu muset vzdy past plnou cestu.
using System;

// namespace - jmeny priestor v ktorom je dana  trieda umiestnena. 
// dany namespace by mal byt jedinecny, a vystizny. moze obsahovat tecky.
// casto "firma(pripadne web domena-urcite jedinecna:) )"."program"."konkretny namespace podla funkcie napr WebAdministration"
namespace MW5_cv01
{
  internal class Program
  {
    /* Main funkce musi byt staticka, musi se takto jmenovat, nema navratovou hodnotu
     * args je pole retezcu, ktere predstavuje parametry programu, se kterymi je spusten.
     * Nemuze volat jinou metodu, ktera staticka neni!
     */
    internal static void Main(string[] args)
    {
      //ProvedForCyklus();

      //ProvedWhileCyklus();

      //PredvedVetveni(5);

      //NacteniVstupu();

      Pocitej();

      //pro zastaveni programu pred ukoncenim
      Console.ReadKey();
    }

    private static void Pocitej()
    {
      Console.WriteLine("Zadej prvni cislo:");
      int prvniCislo = Convert.ToInt32(Console.ReadLine());
      
      Console.WriteLine("Zadej prvni cislo:");
      int druheCislo = Convert.ToInt32(Console.ReadLine());

      int vysledekSouctu = IW5_cv01.Calculator.Math.Secti(prvniCislo, druheCislo);
      Console.WriteLine(vysledekSouctu); // Write line je pretizena

      int vysledekRozdilu = IW5_cv01.Calculator.Math.Odecti(prvniCislo, druheCislo);
      Console.WriteLine(vysledekRozdilu);

      int vysledekSoucinuu = IW5_cv01.Calculator.Math.Vynasob(prvniCislo, druheCislo);
      Console.WriteLine(vysledekSoucinuu);

      int vysledekDeleni = IW5_cv01.Calculator.Math.Vydel(prvniCislo, druheCislo);
      Console.WriteLine(vysledekDeleni);
    }

    //Pozn.: musi byt staticke, jinak by nesly volat z main!
    private static void ProvedForCyklus()
    {
      for (int i = 0; i < 10; i++)
      {
        //staticka metoda ToString je obecna, zdedena od obecne tridy objektu
        Console.WriteLine("For: " + i.ToString());
      }
    }

    private static void ProvedWhileCyklus()
    {
      int index = 0;

      while (index < 11)
      {
        index = index + 1;
        Console.WriteLine("Do - while: " + index.ToString());
      }
    }
    
    private static void PredvedVetveni(int podminka)
    {
      if (podminka > 3)
      {
        Console.WriteLine("podminka JE vetsi nez 3");
      }
      else
      {
        Console.WriteLine("podminka NENI vetsi nez 3");
      }
    }

    private static void NacteniVstupu()
    {
      try
      {
        int a = Convert.ToInt32(Console.ReadLine());
        Console.WriteLine("Dostal jsem: " + a.ToString());
      }
      catch (Exception exception) // ... vice catch zasebou, finally
      {
        Console.WriteLine(exception.Message);
        throw new ApplicationException("HUpsss....");
      }
    }
  }
}
